--This is the internal name of the mod.
local XBARMOD="XSealBar";
local dbver="2";

--Default settings and other info about the mod
XBarModData[XBARMOD]={
	----REQUIRED VALUES----
	["nbuttons"]=11,
	["dbver"]=dbver,
	["dhorizontal"]=true,
	["dhidebar"]=false,
	["dorder"]="az",
	["dscale"]=1,
	["dtooltips"]=true,
	["booktype"]=BOOKTYPE_SPELL,
	["enabled"]=false,
	["nchecks"]=11,
	["nsliders"]=0,
	["ftexint"]=nil,
	["foptioncb"]=XBARMOD.."_OptionCB",
	["fbuttoncb"]=nil,
	["fbuttonid"]=XBARMOD.."_ButtonID",
};

function XSealBar_OnLoad()
	--Each bar must catch its own event notifications
	local Class;

	-- Nonlocalized class check
	_, Class = UnitClass("player");
	if (Class == "PALADIN") then
		-- For this mod, only paladins have seals, so only enable if needed
		XBarModData[XBARMOD]["enabled"]=true;
		this:RegisterEvent("SPELLS_CHANGED");
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("PLAYER_AURAS_CHANGED");
	end

	for i,v in pairs(XSealBarSpells) do
		XBarModData[XBARMOD]["check"..i]=v;
		XBarModData[XBARMOD]["dcheck"..i]=true;
	end
end

function XSealBar_OnEvent()
	local refreshdb=false;

	-- XBar has built in functionality to update its plugins
	if (event == "SPELLS_CHANGED") then
		XBar_Scale(XBARMOD);
		XBar_Update(XBARMOD);
	elseif (event == "SPELL_UPDATE_COOLDOWN" and XBarPlayerName) then
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "PLAYER_AURAS_CHANGED") then
		XBar_UpdateCooldowns(XBARMOD);
	elseif (event == "PLAYER_ENTERING_WORLD") then
		-- Let XBar know we're here so it can set up our data
		-- Double check just in case XBar hasn't got this yet.
		XBar_BuildPlayerName();
		XBar_RegisterAddon(XBARMOD);
		XBar_Update(XBARMOD);
	end
end

function XSealBar_ButtonID(id,spellname)
	local newid=id;

	if (not XBarData[XBarOptionSet]["mods"][XBARMOD][spellname]) then
		newid=nil;
	end

	return newid;
end

function XSealBar_OptionCB(option,value)
	XBar_Update(XBARMOD);
end
